#pragma semicolon 1
#include <sourcemod>
#include <sdktools>

#define DOOR_MAX 8
new	entityDoor[DOOR_MAX];
new	flagDoorLock[DOOR_MAX];

new Handle:hPluginEnable = INVALID_HANDLE;
new Handle:hDoorLockSpam = INVALID_HANDLE;
new Handle:hDoorLockTrap = INVALID_HANDLE;
new Handle:hDoorOpenRush = INVALID_HANDLE;
new Handle:hDoorLockDown = INVALID_HANDLE;
new Handle:hDoorLockPos = INVALID_HANDLE;
new Handle:hDoorLockMin = INVALID_HANDLE;
new Handle:hDoorLockMax = INVALID_HANDLE;

new Handle:hTimer = INVALID_HANDLE;
new entDoorCount = 0;
new entDoorStart;
new entDoorGoal;
new flagDoorStart;
new flagDoorGoal;
new countDown;
new DoorSound;
new Float:prevTime;
new Float:prevDoorTime;
new bool:isSafeRoom[MAXPLAYERS+1];
new bool:IsSmalltown03;

public Plugin:myinfo = 
{
	name = "L4D Door Lock",
	author = "NiCo-op",
	description = "",
	version = "0.0.1",
	url = "http://nico-op.forjp.net/"
};
public OnPluginStart()
{
	hPluginEnable = CreateConVar("l4d_doorlock",			"1",		"Включить или выключить плагин (вкл:1 / выкл:0)", FCVAR_PLUGIN|FCVAR_SPONLY, true, 0.0, true, 1.0);
	hDoorLockSpam = CreateConVar("l4d_doorlock_spam",		"1",		"Anti-doorspam", FCVAR_PLUGIN|FCVAR_SPONLY, true, 0.0, true, 1.0);
	hDoorLockTrap = CreateConVar("l4d_doorlock_trap",		"100",		"Шанс, что на двери будет ловушка (0-100%)", FCVAR_PLUGIN|FCVAR_SPONLY, true, 0.0, true, 100.0);
	hDoorOpenRush = CreateConVar("l4d_doorlock_rush",		"20",		"Количество паник-эвентов, если ловушка на двери сработала (стандарт:10 / мин:0 / макс:20)", FCVAR_PLUGIN|FCVAR_SPONLY, true, 0.0, true, 20.0);
	hDoorLockDown = CreateConVar("l4d_doorlock_down",		"1",		"Считать ли игрока, который находится в инкапе (стандарт:0 / да:1 / нет:0)", FCVAR_PLUGIN|FCVAR_SPONLY, true, 0.0, true, 1.0);
	hDoorLockMin = CreateConVar("l4d_doorlock_secmin",		"30",		"Количество секунд, которое ловушка на двери будет работать (мининум)", FCVAR_PLUGIN|FCVAR_SPONLY, true, 0.0, true, 300.0);
	hDoorLockMax = CreateConVar("l4d_doorlock_secmax",		"90",		"Количество секунд, которое ловушка на двери будет работать (максимум)", FCVAR_PLUGIN|FCVAR_SPONLY, true, 0.0, true, 300.0);
	hDoorLockPos = CreateConVar("l4d_doorlock_pos",			"750",		"Расстояние, на котором можно открыть дверь или включить ловушку на двери", FCVAR_PLUGIN|FCVAR_SPONLY, true, 0.0, true, 5000.0);

	LoadTranslations("l4d_doorlock.phrases");

	HookEvent("round_start_post_nav", OnRoundStartPostNav);
	HookEvent("mission_lost", OnRoundEnd);
	HookEvent("player_death", OnPlayerLeftCheckpoint);
	HookEvent("player_left_checkpoint", OnPlayerLeftCheckpoint);
	HookEvent("player_entered_checkpoint", OnPlayerEnteredCheckpoint);
	HookEvent("player_use", OnPlayerUse, EventHookMode_Pre);
	HookEvent("player_spawn", OnPlayerSpawn);
	HookEvent("bot_player_replace", OnBotPlayerReplace);
}
IsALLinSafeRoom()
{
	new count = 0;
	new alive = 0;
	new max = GetMaxClients();
	for(new i=1; i<=max; i++)
	{
		if(IsClientConnected(i) && IsClientInGame(i) && !IsFakeClient(i) && IsPlayerAlive(i) && GetClientTeam(i) == 2 && (!GetConVarBool(hDoorLockDown) || !GetEntProp(i, Prop_Send, "m_isIncapacitated")))
		{
			if(isSafeRoom[i]) count++;
			alive++;
		}
	}
	return (alive <= count) ? 1 : 0;
}
GetEntitySafeRoomDoor()
{
	decl String:sClassname[] = "prop_door_rotating_checkpoint";
	new door_count = 0;
	new door_start = -1;
	new door_goal = -1;
	new index = -1;
	while((index = FindEntityByClassname(index, sClassname)) != -1)
	{
		if(GetEntProp(index, Prop_Data, "m_bLocked") > 0) door_start = index;
		else door_goal = index;
		DoorUnlockFlag(index);
		door_count++;
	}
	entDoorCount = door_count;
	entDoorStart = door_start;
	entDoorGoal = door_goal;
}
DoorUnlockFlag(entity)
{
	for(new i=0; i<DOOR_MAX; i++)
	{
		if(!entityDoor[i]||entityDoor[i] == entity)
		{
			entityDoor[i] = entity;
			flagDoorLock[i] = 0;
			break;
		}
	}
}
DoorLockFlag(entity)
{
	for(new i=0; i<DOOR_MAX; i++)
	{
		if(!entityDoor[i]||entityDoor[i] == entity)
		{
			entityDoor[i] = entity;
			flagDoorLock[i] = entity;
			break;
		}
	}
}
CheckDoor(entity)
{
	for(new i=0; i<DOOR_MAX; i++)
	{
		if(entityDoor[i] == entity) return entity;
	}
	return 0;
}
CheckDoorLock(entity)
{
	for(new i=0; i<DOOR_MAX; i++)
	{
		if(entityDoor[i] == entity)
		{
			return flagDoorLock[i];
		}
	}
	return 0;
}
public Action:OnRoundStartPostNav(Handle:event, const String:name[], bool:dontBroadcast)
{
	if(!GetConVarBool(hPluginEnable) || IsSmalltown03) return Plugin_Continue;
	if(entDoorCount) return Plugin_Continue;

	prevTime = 0.0;
	prevDoorTime = 0.0;
	flagDoorStart = 0;
	flagDoorGoal = 0;
	for(new i=0; i<DOOR_MAX; i++)
	{
		entityDoor[i] = 0;
		flagDoorLock[i] = 0;
	}
	GetEntitySafeRoomDoor();

	new min = GetConVarInt(hDoorLockMin);
	new max = GetConVarInt(hDoorLockMax);
	new trap = GetConVarInt(hDoorLockTrap);
	countDown = (GetRandomInt(1, 100) <= trap) ? GetRandomInt(min, max) : 0;

	if(entDoorCount > 2) countDown = 0;
	if(entDoorGoal > 0)
	{
		AcceptEntityInput(entDoorGoal, "Close");
		DoorLockFlag(entDoorGoal);
		AcceptEntityInput(entDoorGoal, "Lock");
		SetEntProp(entDoorGoal, Prop_Data, "m_hasUnlockSequence", 1);
	}
	for(new i=0; i<MAXPLAYERS+1; i++)
	{
		isSafeRoom[i] = false;
	}
	return Plugin_Continue;
}
public OnMapStart()
{
	switch (GetRandomInt(0,6))
	{
		case 0:{PrecacheSound("music/flu/jukebox/portal_still_alive.wav", true);
			DoorSound = 0;}
		case 1:{PrecacheSound("music/flu/jukebox/re_your_brains.wav", true);
			DoorSound = 1;}
		case 2:{PrecacheSound("music/flu/jukebox/midnightride.wav", true);
			DoorSound = 2;}
		case 3:{PrecacheSound("music/flu/jukebox/badman.wav", true);
			DoorSound = 3;}
		case 4:{PrecacheSound("music/flu/jukebox/all_i_want_for_xmas.wav", true);
			DoorSound = 4;}
		case 5:{PrecacheSound("music/flu/jukebox/save_me_some_sugar_mono.wav", true);
			DoorSound = 5;}
		case 6:{PrecacheSound("music/flu/jukebox/thesaintswillnevercome.wav", true);
			DoorSound = 6;}
	}
	
	decl String:s_currentMap[64];
	GetCurrentMap(s_currentMap, sizeof(s_currentMap));
	if(StrContains(s_currentMap, "l4d_smalltown03_ranchhouse", false) != -1) IsSmalltown03 = true;
	else IsSmalltown03 = false;
}
public OnMapEnd()
{
	hTimer = INVALID_HANDLE;
	entDoorCount = 0;
}
public Action:OnRoundEnd(Handle:event, const String:name[], bool:dontBroadcast)
{
	hTimer = INVALID_HANDLE;
	entDoorCount = 0;
	return Plugin_Continue;
}
public Action:OnPlayerLeftCheckpoint(Handle:event, const String:name[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	if(client && IsClientConnected(client) && IsClientInGame(client)) isSafeRoom[client] = false;
}
public Action:OnPlayerEnteredCheckpoint(Handle:event, const String:name[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	if(client && IsClientConnected(client) && IsClientInGame(client) && IsPlayerAlive(client) && GetClientTeam(client) == 2) isSafeRoom[client] = true;
	return Plugin_Continue;
}
public Action:OnPlayerUse(Handle:event, const String:name[], bool:dontBroadcast)
{
	if(!GetConVarBool(hPluginEnable) || IsSmalltown03) return Plugin_Continue;
	new entity = GetEventInt(event, "targetid");
	if (!IsValidEdict(entity)) return Plugin_Continue;
	new Float:nowTime = GetGameTime();
	decl String:item[64];
	GetEdictClassname(entity, item, sizeof(item));
	if(StrContains(item, "prop_door_rotating_checkpoint", false) != -1 && entity == entDoorGoal && !flagDoorGoal)
	{
		decl String:username[MAX_NAME_LENGTH];
		decl Float:vec[3], Float:vecPlayer[3];
		new client = GetClientOfUserId(GetEventInt(event, "userid"));
		GetClientAbsOrigin(client, vecPlayer);

		if(GetConVarBool(hDoorLockPos))
		{
			new max = GetMaxClients();
			new count = 0;
			for(new i=1; i<=max; i++)
			{
				if(IsClientConnected(i) && IsClientInGame(i) && IsPlayerAlive(i) && !IsFakeClient(i) && GetClientTeam(i) == 2 && (!GetConVarBool(hDoorLockDown) || !GetEntProp(i, Prop_Send, "m_isIncapacitated")))
				{
					GetClientAbsOrigin(i, vec);
					if(FloatAbs(FloatAbs(vec[0]) - FloatAbs(vecPlayer[0])) + FloatAbs(FloatAbs(vec[1]) - FloatAbs(vecPlayer[1])) + FloatAbs(FloatAbs(vec[2]) - FloatAbs(vecPlayer[2])) > GetConVarFloat(hDoorLockPos))
					{
						if(count++ < 3)
						{
							// for doorspamer
							if(nowTime - prevDoorTime >= 0.0 && nowTime - prevDoorTime <= 8.00)
							{
								if(count == 1)
								{
									PrintToChat(client, "%t", "hint_doorlock");
								}
								GetClientName(i, username, sizeof(username));
								PrintToChat(i, "%t", "go_to_doorlock", username);
							}
							// for all
							else
							{
								if(count == 1)
								{
									//GetClientName(client, username, sizeof(username));
									
									//PrintToChatAll("%t", "block_doorlock", username);
									//PrintToChatAll("%t", "hint_doorlock");
								}
								GetClientName(i, username, sizeof(username));
								PrintToChatAll("%t", "go_to_doorlock", username);
							}
						}
					}
				}
			}
			if(count)
			{
				prevDoorTime = nowTime;
				return Plugin_Continue;
			}
		}
		flagDoorGoal = 1;
		if(countDown <= 0)
		{
			AcceptEntityInput(entity, "Unlock");
			AcceptEntityInput(entity, "forceclosed");
			AcceptEntityInput(entity, "Open");
		}
		else
		{
			new mobs = GetConVarInt(hDoorOpenRush);
			new flags = GetCommandFlags("z_spawn");
			SetCommandFlags("z_spawn", flags & ~FCVAR_CHEAT);
			for(new i=0; i<mobs; i++)
			{
				FakeClientCommand(client, "z_spawn mob auto");
			}
			SetCommandFlags("z_spawn", flags);

			hTimer = CreateTimer(1.0, TimerDoorCountDown, entity, TIMER_REPEAT);
			switch (DoorSound)
			{
				case 0: EmitSoundToAll("music/flu/jukebox/portal_still_alive.wav");
				case 1: EmitSoundToAll("music/flu/jukebox/re_your_brains.wav");
				case 2: EmitSoundToAll("music/flu/jukebox/midnightride.wav");
				case 3: EmitSoundToAll("music/flu/jukebox/badman.wav");
				case 4: EmitSoundToAll("music/flu/jukebox/all_i_want_for_xmas.wav");
				case 5: EmitSoundToAll("music/flu/jukebox/save_me_some_sugar_mono.wav");
				case 6: EmitSoundToAll("music/flu/jukebox/thesaintswillnevercome.wav");
			}
			TimerDoorCountDown(hTimer, entity);
			
			PrintToChatAll("%t", "Door_started", client);
		}
	}
	else if(StrContains(item, "prop_door_rotating_checkpoint", false) != -1 && entity == entDoorStart && !flagDoorStart && !GetEntProp(entity, Prop_Data, "m_bLocked"))
	{
		flagDoorStart = 1;
	}
	if(nowTime - prevTime >= 0.0 && nowTime - prevTime <= 0.25) return Plugin_Continue;
	if(StrContains(item, "prop_door_rotating_checkpoint", false) != -1 && CheckDoor(entity))
	{
		new status = GetEntProp(entity, Prop_Data, "m_eDoorState");
		new flags = ((!flagDoorGoal || countDown <= 0) && CheckDoorLock(entity));
		if(IsALLinSafeRoom())
		{
			if(status == 2 && flags && GetEntProp(entity, Prop_Data, "m_bLocked"))
			{
				SetEntProp(entity, Prop_Data, "m_hasUnlockSequence", 0);
				AcceptEntityInput(entity, "Unlock");
				AcceptEntityInput(entity, "forceclosed");
				AcceptEntityInput(entity, "Close");
			}
		}
		else if(!status && flags)
		{
			SetEntProp(entity, Prop_Data, "m_hasUnlockSequence", 0);
			AcceptEntityInput(entity, "Unlock");
			AcceptEntityInput(entity, "forceclosed");
			AcceptEntityInput(entity, "Open");
		}
		else if((status&3)%3 && !GetEntProp(entity, Prop_Data, "m_bLocked"))
		{
			// anti-doorspam
			if(GetConVarBool(hDoorLockSpam))
			{
				DoorLockFlag(entity);
				AcceptEntityInput(entity, "forceclosed");
				AcceptEntityInput(entity, "Lock");
				SetEntProp(entity, Prop_Data, "m_hasUnlockSequence", 1);
			}
		}
		else if(status == 2 && GetEntProp(entity, Prop_Data, "m_bLocked"))
		{
			decl String:username[MAX_NAME_LENGTH];
			//new client = GetClientOfUserId(GetEventInt(event, "userid"));
			new max = GetMaxClients();
			new count = 0;
			for(new i=1; i<=max; i++)
			{
				if(!isSafeRoom[i] && IsClientConnected(i) && IsClientInGame(i) && IsPlayerAlive(i) && !IsFakeClient(i) && GetClientTeam(i) == 2 && (!GetConVarBool(hDoorLockDown) || !GetEntProp(i, Prop_Send, "m_isIncapacitated")))
				{
					if(count++ < 3)
					{
						GetClientName(i, username, sizeof(username));
						// for doorspamer
						if(nowTime - prevTime >= 0.0 && nowTime - prevTime <= 3.00)
						{
							PrintToChat(i, "%t", "enter_doorlock", username);
						}
						// for all
						else
						{
							PrintToChatAll("%t", "enter_doorlock", username);
						}
					}
				}
			}
		}
	}
	prevTime = nowTime;
	return Plugin_Continue;
}
public Action:TimerDoorCountDown(Handle:timer, any:entity)
{
	if(timer == hTimer)
	{
		//EmitSoundToAll("music/flu/jukebox/portal_still_alive.wav", entity, SNDCHAN_AUTO, SNDLEVEL_RAIDSIREN, SND_NOFLAGS, SNDVOL_NORMAL, SNDPITCH_LOW, -1, NULL_VECTOR, NULL_VECTOR, true, 0.0);
		if(countDown > 0)
		{
			new max = GetMaxClients();
			for(new i=1; i<=max; i++)
			{
				if(IsClientConnected(i) && IsClientInGame(i) && !IsFakeClient(i) && GetClientTeam(i) == 2)
				{
					PrintHintText(i, "%t", "SEC", countDown);
				}
			}
			countDown--;
			return Plugin_Continue;
		}
		SetEntProp(entity, Prop_Data, "m_hasUnlockSequence", 0);
		AcceptEntityInput(entity, "Unlock");
		AcceptEntityInput(entity, "Open");

		new max = GetMaxClients();
		for(new i=1; i<=max; i++)
		{
			if(IsClientConnected(i) && IsClientInGame(i) && !IsFakeClient(i) && GetClientTeam(i) == 2)
			{
				PrintHintText(i, "%t", "DOOR_OPENED");
			}
		}
	}
	return Plugin_Stop;
}
// afk -> join
public Action:TimerCheckSafeRoom(Handle:timer, any:client)
{
	if(client <= 0 || !IsClientConnected(client) || !IsClientInGame(client) || !IsPlayerAlive(client) || GetClientTeam(client) != 2) return Plugin_Stop;

	decl Float:vec[3], Float:vecPlayer[3];
	GetClientAbsOrigin(client, vecPlayer);

	new max = GetMaxClients();
	for(new i=1; i<=max; i++)
	{
		if(client != i && isSafeRoom[i] && IsClientConnected(i) && IsClientInGame(i) && IsPlayerAlive(i) && GetClientTeam(i) == 2)
		{
			GetClientAbsOrigin(i, vec);
			if(FloatAbs(FloatAbs(vec[0]) - FloatAbs(vecPlayer[0])) + FloatAbs(FloatAbs(vec[1]) - FloatAbs(vecPlayer[1])) + FloatAbs(FloatAbs(vec[2]) - FloatAbs(vecPlayer[2])) < 1000.0)
			{
				isSafeRoom[client] = true;
				break;
			}
		}
	}
	return Plugin_Stop;
}
public Action:OnPlayerSpawn(Handle:event, const String:name[], bool:dontBroadcast)
{
	CreateTimer(0.25, TimerCheckSafeRoom, GetClientOfUserId(GetEventInt(event, "userid")), TIMER_FLAG_NO_MAPCHANGE);
	return Plugin_Continue;
}
public Action:OnBotPlayerReplace(Handle:event, const String:name[], bool:dontBroadcast)
{
	TimerCheckSafeRoom(INVALID_HANDLE, GetClientOfUserId(GetEventInt(event, "player")));
	return Plugin_Continue;
}
/*public IsSmalltown03()
{
	decl String:s_currentMap[64];
	GetCurrentMap(s_currentMap, sizeof(s_currentMap));

	if(StrContains(s_currentMap, "l4d_smalltown03_ranchhouse", false) != -1) return true;
	return false;
}*/